import List from '../utils/list';
import { EntityType, StringLikeEntityType, MeasureEntity, LocationEntity, TimeEntity } from '../entities';
export declare class ConstantToken<K extends EntityType, V> {
    name: K;
    value: V;
    constructor(name: K, value: V);
    toString(): string;
}
export interface GenericEntityToken {
    type: string;
    value: string | null;
    display?: string | null;
}
export declare type AnyConstantToken = ConstantToken<StringLikeEntityType, string> | ConstantToken<'NUMBER', number> | ConstantToken<'MEASURE' | 'CURRENCY', MeasureEntity> | ConstantToken<'LOCATION', LocationEntity> | ConstantToken<'DATE', Date> | ConstantToken<'TIME', TimeEntity> | ConstantToken<'GENERIC_ENTITY', GenericEntityToken>;
export declare type TokenStream = List<string | AnyConstantToken>;
